<?php
/*
+---------------------------------------------------------------+
|        Gold Orb for e107 v7xx - by Father Barry
|
|        This module for the e107 .7+ website system
|        Copyright Barry Keal 2004-2008
|
|        Released under the terms and conditions of the
|        GNU General Public License (http://gnu.org).
|
+---------------------------------------------------------------+
*/
class gold_orb
{
    function gold_orb()
    {
        global $GOLD_ORB_PREF, $pref, $tp, $gold_sql;
        // get all the details
        $this->load_prefs();
    }
    // ********************************************************************************************
    // *
    // * Gold Orb Load and Save prefs
    // *
    // ********************************************************************************************
    function getdefaultprefs()
    {
        global $GOLD_ORB_PREF;

        $GOLD_ORB_PREF = array('gorb_buyclass' => 255,
            'gorb_minwidth' => 40);
    }
    function save_prefs()
    {
        global $sql, $eArrayStorage, $GOLD_ORB_PREF;
        // save preferences to database
        if (!is_object($sql))
        {
            $sql = new db;
        }
        $tmp = $eArrayStorage->WriteArray($GOLD_ORB_PREF);
        $sql->db_Update('core', "e107_value='$tmp' where e107_name='gold_orb'", false);
        return ;
    }
    function load_prefs()
    {
        global $sql, $eArrayStorage, $GOLD_ORB_PREF;
        // get preferences from database
        if (!is_object($sql))
        {
            $sql = new db;
        }
        $num_rows = $sql->db_Select('core', '*', "e107_name='gold_orb' ");
        $row = $sql->db_Fetch();

        if (empty($row['e107_value']))
        {
            // insert default preferences if none exist
            $this->getDefaultPrefs();
            $tmp = $eArrayStorage->WriteArray($GOLD_ORB_PREF);
            $sql->db_Insert('core', "'gold_orb', '$tmp' ");
            $sql->db_Select('core', '*', "e107_name='gold_orb' ");
        }
        else
        {
            $GOLD_ORB_PREF = $eArrayStorage->ReadArray($row['e107_value']);
        }
        return;
    }
    // ***************************************************************************
    // *
    // *	method 		: 	current_orb($gold_uid)
    // *
    // *	Parameters	:	$gold_uid id of user to write
    // *
    // *	Returns		:	name of the current orb for selected user
    // *
    // ***************************************************************************
    function current_orb($gold_uid)
    {
        global $gold_obj;
        if (!array_key_exists($gold_uid, $gold_obj->gold_member))
        {
            // otherwise load the user data
            $gold_obj->load_gold($gold_uid);
        }
        return $gold_obj->gold_member[$gold_uid]['gold_orb'];
    }
    // ***************************************************************************
    // *
    // *	method 		: 	show_sample($orbname)
    // *
    // *	Parameters	: 	$orbname as string for orb name
    // *
    // *	Returns		:	sample of orb
    // *				:
    // *
    // ***************************************************************************
    function show_sample($orbname)
    {
        global $gold_obj, $tp;
        if (!is_readable(e_PLUGIN . 'gold_orb/orbs/' . $orbname . '/orb.php'))
        {
            return false;
        }
        else
        {
            // get the orb
            unset($orb);
            unset($gorb);
            require(e_PLUGIN . 'gold_orb/orbs/' . $orbname . '/orb.php');
            $orb = $gorb[$orbname];

            if ($orb['type'] == 'glow')
            {
                // this is the shadow type
                $browser = $this->browser_detection('full');
                if ($browser[0] == 'ie')
                {
                    // ie browser so glow
                    return'<span style="display:inline-block;"><div style="color: #' . $orb['fontcolour'] . '; FILTER: Glow(Color=#' . $orb['shadowcolour'] . ', Strength=2); width:100%;font-size:' . $orb['fontsize'] . 'px;">' . GOLD_ORB_O_04 . '</div></span>';
                }
                else
                {
                    // else try to shadow
                    return'
	<span
	style="
text-shadow: #' . $orb['shadowcolour'] . ' 2px 2px 2px,#' . $orb['shadowcolour'] . ' -1px -1px 2px;
color: #' . $orb['fontcolour'] . ';
font-size:' . $orb['fontsize'] . 'px;"
>' . GOLD_ORB_O_04 . '</span>
';
                }
            }
            else
            {
                // find out if orb is jpg, png or gif
                if (is_readable(e_PLUGIN . 'gold_orb/samples/' . $orbname . '.png'))
                {
                    // its a png
                    $gorb_orbfile = 'png';
                } elseif (is_readable(e_PLUGIN . 'gold_orb/samples/' . $orbname . '.jpg'))
                {
                    // its a jpg
                    $gorb_orbfile = 'jpg';
                } elseif (is_readable(e_PLUGIN . 'gold_orb/samples/' . $orbname . '.gif'))
                {
                    // its a gif
                    $gorb_orbfile = 'gif';
                }
                else
                {
                    // no existing orb
                    $gorb_orbfile = '';
                }
                if (empty($gorb_orbfile))
                {
                    // no existing orb
                    // get the orb we are going to generate
                    // $gorb_location = $gold_obj->gold_member[$uid]['gold_orb'];
                    if (is_readable(e_PLUGIN . 'gold_orb/orbs/' . $orbname . '/orb.php'))
                    {
                        // require_once(e_PLUGIN . 'gold_orb/orbs/' . $gorb_location . '/orb.php');
                        // $orb = $gorb[$gorb_location];
                        $this->gen_orb($gorb_folder, GOLD_ORB_O_04, $gorb_orbfile, true);
                    }
                    else
                    {
                        echo GOLD_ORB_129 . $gorb_location . $uid . '<br />';
                    }
                }
                return "<img src='" . e_PLUGIN . "gold_orb/samples/{$orbname}.{$gorb_orbfile}' id='{$orbname}' style='border:0px;' title='" . $orbname . "' alt='orb " . $orbname . "' />";
            }
        }
    }
    // ***************************************************************************
    // *
    // *	method 		: 	show_orb($uid, $uname)
    // *
    // *	Parameters	: 	$uid as integer for user
    // *				:	$uname as string for user name
    // *
    // *	Returns		:	username or the orbed name as a string
    // *				:
    // *
    // ***************************************************************************
    function show_orb($uid, $uname)
    {
        global $gold_obj, $tp;
        // load the gold settings for this user
        $gold_obj->load_gold($uid);
        $users_orb = $gold_obj->gold_member[$uid]['gold_orb'];

        // if ($uid > 0)
        // {
        $username = $gold_obj->gold_member[$uid]['user_name'];
        // }
        if ($users_orb == '' || !is_readable(e_PLUGIN . 'gold_orb/orbs/' . $users_orb . '/orb.php'))
        {
            // no orb wielded so just return name.
            if (empty($username))
            {
                // check if user name defined if not make it unknown user
                $username = GOLD_ORB_130;
            }
            return $username;
        }
        else
        {
            // get the orb
            $gorb_location = $gold_obj->gold_member[$uid]['gold_orb'];

            if (is_readable(e_PLUGIN . 'gold_orb/orbs/' . $gorb_location . '/orb.php'))
            {
                require(e_PLUGIN . 'gold_orb/orbs/' . $gorb_location . '/orb.php');
                $orb = $gorb[$gorb_location];
            }
            if ($orb['type'] == 'glow')
            {

                if (empty($username))
                {
                    // check if user name defined if not make it unknown user
                    $username = GOLD_ORB_130;
                }
                $browser = $this->browser_detection('full');
                if ($browser[0] == 'ie')
                {
                    // ie browser so glow
                    return'<span style="display:inline-block;"><div style="color:#' . $orb['fontcolour'] . '; FILTER: Glow(Color=#' . $orb['shadowcolour'] . ', Strength=2); width:100%;font-size:' . $orb['fontsize'] . 'px;">' . $tp->toHTML($username) . '</div></span>';
                }
                else
                {
                    // else try to shadow
                    return'
	<span
	style="
text-shadow: #' . $orb['shadowcolour'] . ' 2px 2px 2px,#' . $orb['shadowcolour'] . ' -1px -1px 2px;
color: #' . $orb['fontcolour'] . ';
font-size:' . $orb['fontsize'] . 'px;"
>' . $tp->toHTML($username) . '</span>
';
                }
            }
            else
            {
                $wielded = $gold_obj->gold_member[$uid]['gold_orb'];

                if (is_readable(e_PLUGIN . 'gold_orb/orbs/' . $wielded . '/orb.php'))
                {
                    // if the orb is there then get it
                    require(e_PLUGIN . 'gold_orb/orbs/' . $wielded . '/orb.php');
                }
                // find out if orb is jpg, png or gif
                if (is_readable(e_PLUGIN . 'gold_orb/wield/' . $uid . '.png'))
                {
                    // its a png
                    $gorb_orbfile = 'png';
                } elseif (is_readable(e_PLUGIN . 'gold_orb/wield/' . $uid . '.jpg'))
                {
                    // its a jpg
                    $gorb_orbfile = 'jpg';
                } elseif (is_readable(e_PLUGIN . 'gold_orb/wield/' . $uid . '.gif'))
                {
                    // its a gif
                    $gorb_orbfile = 'gif';
                }
                else
                {
                    // no existing orb
                    $gorb_orbfile = '';
                }
                if (empty($gorb_orbfile))
                {
                    // no existing orb
                    // get the users name
                    $username = $gold_obj->gold_member[$uid]['user_name'];

                    if (empty($username))
                    {
                        // check if user name defined if not make it unknown user
                        $username = GOLD_ORB_130;
                    }
                    // get the orb we are going to generate
                    // $gorb_location = $gold_obj->gold_member[$uid]['gold_orb'];
                    if (is_readable(e_PLUGIN . 'gold_orb/orbs/' . $gorb_location . '/orb.php'))
                    {
                        // require_once(e_PLUGIN . 'gold_orb/orbs/' . $gorb_location . '/orb.php');
                        // $orb = $gorb[$gorb_location];
                        $this->gen_orb($uid, $username, $orb);
                    }
                    else
                    {
                        echo GOLD_ORB_129 . $gorb_location . $uid . '<br />';
                    }
                }
                $gid = time() . $uid;
                return "<img src='" . e_PLUGIN . "gold_orb/wield/{$uid}.{$gorb_orbfile}' id='gold{$gid}' style='border:0px;' title='" . $gold_uname . "' alt='orb " . $gold_uname . "' />";
            }
        }
    }
    // ***************************************************************************
    // *
    // *	method 		: 	orb_exists($item, $uid = USERID)
    // *
    // *	Parameters	: 	$item as string for orb
    // *				:	orb_fem orb_flame orb_toxin orb_frost
    // *				:	orb_dark orb_light
    // *				:	$uid as integer for user
    // *
    // *	Returns		:	true if user posesses
    // *				:	FALSE in not
    // *
    // ***************************************************************************
    function orb_exists($item, $gold_userid = USERID)
    {
        global $gold_obj;
        global $gold_sql, $GOLD_ORB_PREF;
        if (!array_key_exists($gold_userid, $gold_obj->gold_member))
        {
            $this->load_gold($gold_userid);
        }
        $inv = $gold_obj->gold_member[$gold_userid]['gold_inv'];

        $orb_array = unserialize($inv);
        if (array_key_exists($item, $orb_array))
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    // ***************************************************************************
    // *
    // *	method 		: 	buy_orb($item, $uid = USERID)
    // *
    // *	Parameters	: 	$item as string for orb
    // *				:	orb_fem orb_flame orb_toxin orb_frost
    // *				:	orb_dark orb_light
    // *				:	$uid as integer for user
    // *
    // *	Returns		:	nothing
    // *				:
    // *
    // ***************************************************************************
    function buy_orb($item, $uid = USERID)
    {
        global $gold_sql, $gold_obj;
        $gold_sql->db_Select('gold_system', 'gold_inv', 'where gold_id="' . $uid . '"', 'nowhere', false);
        $row = $gold_sql->db_Fetch();
        $inv = $row['gold_inv'];
        if ($gorb_uprow['gold_inv'] == 'b:0;' || $gorb_uprow['gold_inv'] == 'N;')
        {
            $gold_sql->db_Update('gold_system', "gold_inv='' WHERE gold_id='{$uid}'", false);
            $gold_sql->db_Select('gold_system', 'gold_inv', 'where gold_id="' . $uid . '"', 'nowhere', false);
            $row = $gold_sql->db_Fetch();
            $inv = $row['gold_inv'];
        }

        if ($inv == '' && !empty($item))
        {
            $orb_array = array($item => $item);
            $orb_all = serialize($orb_array);
            $gold_sql->db_Update('gold_system', "gold_inv='{$orb_all}' WHERE gold_id='{$uid}'", false);
        } elseif (!empty($item))
        {
            $orb_array = unserialize($inv);
            $buy_orb_array = array($item => $item);
            $new_inv = array_merge($orb_array, $buy_orb_array);

            $orb_all = serialize($new_inv);
            $gold_sql->db_Update('gold_system', "gold_inv='{$orb_all}' WHERE gold_id='{$uid}'", false);
        }
        $gold_obj->load_gold($uid);
    }
    // ***************************************************************************
    // *
    // *	method 		: 	wield_orb($item, $uid = USERID)
    // *
    // *	Parameters	: 	$uid as integer for user
    // *				:	$item as string object to be wielded
    // *
    // *	Returns		:	true if no error
    // *				:	false if failed to wield
    // *
    // ***************************************************************************
    function wield_orb($item, $uid = USERID)
    {
        global $gold_sql, $gold_obj;

        if ($gold_sql->db_Update('gold_system', "gold_orb='{$item}' WHERE gold_id='{$uid}'"))
        {
            if (file_exists(e_PLUGIN . 'gold_orb/wield/' . $uid . '.png'))
            {
                unlink(e_PLUGIN . 'gold_orb/wield/' . $uid . '.png');
            }
            $gold_obj->load_gold($uid);
            $username = $gold_obj->gold_member[$uid]['user_name'];
            if (empty($username))
            {
                // check if user name defined if not make it unknown user
                $username = GOLD_ORB_130;
            }
            require(e_PLUGIN . 'gold_orb/orbs/' . $item . '/orb.php');
            $item = $gorb[$item];
            $this->gen_orb($uid, $username, $item, false);
            return true;
        }
        else
        {
            return false;
        }
    }
    // ***************************************************************************
    // *
    // *	method 		: 	gen_orb($userid, $username, $orb)
    // *
    // *	Parameters	: 	$userid as integer for user
    // *				:	$username as string object for user name
    // *				:	$orb as string the orb to use
    // *				:	orb_fem orb_flame orb_toxin orb_frost
    // *				:	orb_dark orb_light
    // *	Returns		:	nothing
    // *				:
    // *
    // ***************************************************************************
    function gen_orb($userid, $username, $orb, $sample = false)
    {
        // print_a( $orb);
        // print "$userid, $username, $orb <br />";
        // print_a($orb);
        global $GOLD_ORB_PREF;

        if (!empty($orb['font']) && file_exists(e_PLUGIN . 'gold_orb/fonts/' . $orb['font']))
        {
            $font = e_PLUGIN . 'gold_orb/fonts/' . $orb['font'];
        }
        else
        {
            $font = e_PLUGIN . 'gold_orb/fonts/arial.ttf' ;
        }
        if ($orb['type'] == 'plain')
        {
            // doing a transparent orb
            $angle = 0;
            $fontSize = $orb['fontsize'];
            $text = GOLD_ORB_O_04;
            $size = imageTTFBBox($fontSize, $angle, $font, $text);
            $image = imageCreateTrueColor(abs($size[2]) + abs($size[0]), abs($size[7]) + abs($size[1]));
            imageSaveAlpha($image, true);
            ImageAlphaBlending($image, false);

            $transparentColor = imagecolorallocatealpha($image, 200, 200, 200, 127);
            imagefill($image, 0, 0, $transparentColor);

            $textColor1 = imagecolorallocate($image, 200, 100, 10);

            imagettftext($image, $fontSize, $angle, 0, abs($size[5]), $textColor1, $font, $text);
            if ($sample)
            {
                unlink(e_PLUGIN . 'gold_orb/samples/' . $userid . '.png');
                Imagepng($image, e_PLUGIN . 'gold_orb/samples/' . $userid . '.png');
            }
            else
            {
                unlink(e_PLUGIN . 'gold_orb/wield/' . $userid . '.png');
                Imagepng($image, e_PLUGIN . 'gold_orb/wield/' . $userid . '.png');
            }
        }
        else
        {
            $username = ' ' . $username . ' ';
            $backfile = e_PLUGIN . 'gold_orb/orbs/' . $orb['name'] . '/' . $orb['backimage'];
            if (!empty($orb['backimage']) && file_exists($backfile))
            {
                $dofromimage = true;
                $anti = -1;
            }
            else
            {
                $dofromimage = false;
                $anti = 1;
            }
            $text = $username;
            $fontsize = $orb['fontsize'];
            $size = imagettfbbox($fontsize, 0, $font, $text);
            // Size of text box
            $dx = abs($size[2] - $size[0]);
            $xwidth = $dx;
            if ($GOLD_ORB_PREF['gorb_minwidth'] > 0 && $xwidth < $GOLD_ORB_PREF['gorb_minwidth'])
            {
                // if the size of the text box is less than the minimum
                // make the background the minimum size
                $xwidth = $GOLD_ORB_PREF['gorb_minwidth'];
            }
            $dy = abs($size[5] - $size[3]);
            $xpad = 2 * $orb['hpad'];
            $ypad = 2 * $orb['vpad'];
            // width of box
            $box_x = $xwidth + $xpad;
            $text_x = (int)($box_x / 2) - (int)($dx / 2);
            $box_y = $dy + $ypad;
            $text_y = (int)(($box_y) - (($box_y / 2) - ($dy / 2)) -1);
            // print "{$orb['title']} - dx $dx - xpad $xpad - boxx $box_x - textx $text_x <br>";
            // print "{$orb['title']} - dy $dy - ypad $ypad - boxy $box_y - texty $text_y <br>";
            if ($dofromimage)
            {
                $size_orig = getimagesize($backfile);
                // print_a($size_orig);
                $ginfo = getimagesize($backfile);
                $gtype = image_type_to_mime_type($ginfo[2]);
                switch ($gtype)
                {
                    case 'image/png':
                        $im_src = imagecreatefrompng($backfile);
                        $gorb_type = 'png';
                        break;
                    case 'image/gif':
                        $im_src = imagecreatefromgif($backfile);
                        $gorb_type = 'gif';
                        break;
                    case 'image/jpeg':
                        $im_src = imagecreatefromjpeg($backfile);
                        $gorb_type = 'jpg';
                        break;
                }
                // $im_src = imagecreatefromgif($backfile);
                $new_height = $box_y;
                // $new_width = $dx + $xpad;
                $new_width = $box_x;
                // print "$new_height $new_width<br />";
                $width = $size_orig[0];
                $height = $size_orig[1];
                $im = imagecreate($new_width, $new_height);
                imagecopyresampled($im, $im_src, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
            }
            else
            {
                $gorb_type = 'png';
                $im = imagecreate($box_x, $box_y);
            }
            imagealphablending($im, false);

            $col = imagecolorallocatealpha($im, 0, 0, 0, 127);
            $black = ImageColorAllocate($im, 0, 0, 0);

            $fred = $orb['backcolour'];
            $red = hexdec(substr($fred, 0, 2));
            $green = hexdec(substr($fred, 2, 2));
            $blue = hexdec(substr($fred, 4, 2));
            $bkgrnd = ImageColorAllocate($im, $red, $green, $blue);

            $fred = $orb['forecolour'];
            $red = hexdec(substr($fred, 0, 2));
            $green = hexdec(substr($fred, 2, 2));
            $blue = hexdec(substr($fred, 4, 2));
            $white = ImageColorAllocate($im, $red , $green , $blue);

            $fred = $orb['fontcolour'];
            $red = hexdec(substr($fred, 0, 2));
            $green = hexdec(substr($fred, 2, 2));
            $blue = hexdec(substr($fred, 4, 2));
            $fore = ImageColorAllocate($im, $red, $green, $blue);

            $fred = $orb['shadowcolour'];
            $red = hexdec(substr($fred, 0, 2));
            $green = hexdec(substr($fred, 2, 2));
            $blue = hexdec(substr($fred, 4, 2));
            $shadow = ImageColorAllocate($im, $red, $green, $blue);
            // ImageRectangle($im, 0, 0, $dx + $xpad-1, $dy + $ypad-1, $black);
            if (!$dofromimage)
            {
                if ($orb['type'] == 'square')
                {
                    // ImagefilledRectangle($im, 0, 0, $dx + $xpad, $dy + $ypad, $white);
                    ImagefilledRectangle($im, 0, 0, $box_x, $box_y, $white);
                }
                else
                {
                    // $this->imagefillroundedrect($im, 0, 0, $dx + $xpad-1, $dy + $ypad-1, 10, $col);
                    $this->imagefillroundedrect($im, 0, 0, $box_x-1, $box_y-1, 10, $col);
                    // $this->imagefillroundedrect($im, 0, 0, $dx + $xpad, $dy + $ypad, 10, $white);
                    $this->imagefillroundedrect($im, 0, 0, $box_x, $box_y, 10, $white);
                }
            }
            if ($orb['shadow'] == 1)
            {
                // ImageTTFText($im, $fontsize, 0, (int)($xpad / 2) + 1, $dy + (int)($ypad / 2), $shadow , $font, $text);
                ImageTTFText($im, $fontsize, 0, $text_x + 1, $text_y, $shadow , $font, $text);
            }
            // ImageTTFText($im, $fontsize, 0, (int)($xpad / 2), $dy + (int)($ypad / 2)-1, $fore , $font, $text);
            ImageTTFText($im, $fontsize, 0, $text_x, $text_y-1, $fore , $font, $text);
            imagealphablending($im, false);
            imagesavealpha($im, true);
            if ($sample)
            {
                switch ($gorb_type)
                {
                    case 'png':
                        unlink(e_PLUGIN . 'gold_orb/samples/' . $userid . '.png');
                        Imagepng($im, e_PLUGIN . 'gold_orb/samples/' . $userid . '.png');
                        break;
                    case 'gif':
                        unlink(e_PLUGIN . 'gold_orb/samples/' . $userid . '.gif');
                        Imagegif($im, e_PLUGIN . 'gold_orb/samples/' . $userid . '.gif');
                        break;
                    case 'jpg':
                        unlink(e_PLUGIN . 'gold_orb/samples/' . $userid . '.jpg');
                        Imagejpeg($im, e_PLUGIN . 'gold_orb/samples/' . $userid . '.jpg');
                        break;
                }
            }
            else
            {
                // print "WW $userid";
                // Imagepng($im, e_PLUGIN . 'gold_orb/wield/' . $userid . '.png');
                switch ($gorb_type)
                {
                    case 'png':
                        unlink(e_PLUGIN . 'gold_orb/wield/' . $userid . '.png');
                        Imagepng($im, e_PLUGIN . 'gold_orb/wield/' . $userid . '.png');
                        break;
                    case 'gif':
                        unlink(e_PLUGIN . 'gold_orb/wield/' . $userid . '.gif');
                        Imagegif($im, e_PLUGIN . 'gold_orb/wield/' . $userid . '.gif');
                        break;
                    case 'jpg':
                        unlink(e_PLUGIN . 'gold_orb/wield/' . $userid . '.jpg');
                        Imagejpeg($im, e_PLUGIN . 'gold_orb/wield/' . $userid . '.jpg');
                        break;
                }
            }
            ImageDestroy($im);
            ImageDestroy($im_src);
        }
    }
    function imagefillroundedrect(&$im, $x, $y, $cx, $cy, $rad, $col)
    {
        // Draw the middle cross shape of the rectangle
        imagefilledrectangle($im, $x, $y + $rad, $cx, $cy - $rad, $col);
        imagefilledrectangle($im, $x + $rad, $y, $cx - $rad, $cy, $col);

        $dia = $rad * 2;
        // Now fill in the rounded corners
        imagefilledellipse($im, $x + $rad, $y + $rad, $rad * 2, $dia, $col);
        imagefilledellipse($im, $x + $rad, $cy - $rad, $rad * 2, $dia, $col);
        imagefilledellipse($im, $cx - $rad, $cy - $rad, $rad * 2, $dia, $col);
        imagefilledellipse($im, $cx - $rad, $y + $rad, $rad * 2, $dia, $col);
    }
    function clear_cache()
    {
        global $e107cache;
        $e107cache->clear("gold_orbs");
    }
    function browser_detection($which_test)
    {
        // initialize variables
        $browser_name = '';
        $browser_number = '';
        // get userAgent string
        $browser_user_agent = (isset($_SERVER['HTTP_USER_AGENT'])) ? strtolower($_SERVER['HTTP_USER_AGENT']) : '';
        // pack browser array
        // values [0]= user agent identifier, lowercase, [1] = dom browser, [2] = shorthand for browser,
        $a_browser_types[] = array('opera', true, 'op');
        $a_browser_types[] = array('msie', true, 'ie');
        $a_browser_types[] = array('konqueror', true, 'konq');
        $a_browser_types[] = array('safari', true, 'saf');

        $a_browser_types[] = array('firefox', true, 'ff');
        $a_browser_types[] = array('mozilla/4', false, 'ns4');
        $a_browser_types[] = array('gecko', true, 'moz');
        // this will set a default 'unknown' value
        $a_browser_types[] = array('other', false, 'other');

        $i_count = count($a_browser_types);
        for ($i = 0; $i < $i_count; $i++)
        {
            $s_browser = $a_browser_types[$i][0];
            $b_dom = $a_browser_types[$i][1];
            $browser_name = $a_browser_types[$i][2];
            // if the string identifier is found in the string
            if (stristr($browser_user_agent, $s_browser))
            {
                // we are in this case actually searching for the 'rv' string, not the gecko string
                // this test will fail on Galeon, since it has no rv number. You can change this to
                // searching for 'gecko' if you want, that will return the release date of the browser
                if ($browser_name == 'moz')
                {
                    $s_browser = 'rv';
                }
                $browser_number = $this->browser_version($browser_user_agent, $s_browser);
                break;
            }
        }
        // which variable to return
        if ($which_test == 'browser')
        {
            return $browser_name;
        } elseif ($which_test == 'number')
        {
            // this will be null for default other category, so make sure to test for null
            return $browser_number;
        }

        /* this returns both values, then you only have to call the function once, and get
	 the information from the variable you have put it into when you called the function */
        elseif ($which_test == 'full')
        {
            $a_browser_info = array($browser_name, $browser_number);
            return $a_browser_info;
        }
    }
    // function returns browser number or gecko rv number
    // this function is called by above function, no need to mess with it unless you want to add more features
    function browser_version($browser_user_agent, $search_string)
    {
        $string_length = 28; // this is the maximum  length to search for a version number
        // initialize browser number, will return '' if not found
        $browser_number = '';
        // which parameter is calling it determines what is returned
        $start_pos = strpos($browser_user_agent, $search_string);
        // start the substring slice 1 space after the search string
        $start_pos += strlen($search_string) + 1;
        // slice out the largest piece that is numeric, going down to zero, if zero, function returns ''.
        for ($i = $string_length; $i > 0 ; $i--)
        {
            // is numeric makes sure that the whole substring is a number
            if (is_numeric(substr($browser_user_agent, $start_pos, $i)))
            {
                $browser_number = substr($browser_user_agent, $start_pos, $i);
                break;
            }
        }
        return $browser_number;
    }
}
